package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseSupplySource;
import com.ruoyi.web.base.service.IBaseSupplySourceService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 供应来源 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-03
 */
@RestController
@RequestMapping("/base-supply-source")
public class BaseSupplySourceController {
    @Autowired
    private IBaseSupplySourceService baseSupplySourceService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("供应来源管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseSupplySource baseSupplySource, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseSupplySourceService.count(new QueryWrapper<BaseSupplySource>().eq("org_id",loginOrgId).eq("supply_source_num", baseSupplySource.getSupplySourceNum())) >0 ){
            throw new Exception("该编号已存在");
        }

        baseSupplySource.setOrgId(loginOrgId);
        baseSupplySource.setCreateBy(getUsername());
        return success(baseSupplySourceService.save(baseSupplySource));
    }

    @ApiOperation("供应来源管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseSupplySource baseSupplySource, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseSupplySourceService.count(new QueryWrapper<BaseSupplySource>().ne("id",baseSupplySource.getId()).eq("org_id",loginOrgId).eq("supply_source_num", baseSupplySource.getSupplySourceNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseSupplySource.setUpdateBy(getUsername());
        return success(baseSupplySourceService.updateById(baseSupplySource));
    }

    @ApiOperation("供应来源管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseSupplySourceService.removeById(s);
        }
        return success();
    }

    @ApiOperation("供应来源管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){
        return success(baseSupplySourceService.list(new QueryWrapper<BaseSupplySource>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("供应来源管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize,HttpServletRequest request
    ) {
        return success(baseSupplySourceService.page(new Page<BaseSupplySource>(pageNum,pageSize),new QueryWrapper<BaseSupplySource>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("供应来源管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseSupplySourceService.getById(id));
    }
}
